

from .base import MatchingRecDataSet, NextItemRecDataSet


#===================================MatchingRecDataSset===================================


class Amazon2014Books_10104811_ROU(MatchingRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 10
    kcore4item: 10
    star4pos: 4
    ratios: 8,1,1
    splitting: ROU

    Statistics:
    -----------
    +--------+-------+---------------+---------+--------+--------+------------------------+
    | #User  | #Item | #Interactions |  #Train | #Valid | #Test  |        Density         |
    +--------+-------+---------------+---------+--------+--------+------------------------+
    | 109730 | 96421 |    3181759    | 2502323 | 308885 | 370551 | 0.00030072551044609626 |
    +--------+-------+---------------+---------+--------+--------+------------------------+
    """


class Amazon2014Books_10104712_ROU(MatchingRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 10
    kcore4item: 10
    star4pos: 4
    ratios: 7,1,2
    splitting: ROU

    Statistics:
    -----------
    +--------+-------+---------------+---------+--------+--------+------------------------+
    | #User  | #Item | #Interactions |  #Train | #Valid | #Test  |        Density         |
    +--------+-------+---------------+---------+--------+--------+------------------------+
    | 109730 | 96421 |    3181759    | 2181889 | 320434 | 679436 | 0.00030072551044609626 |
    +--------+-------+---------------+---------+--------+--------+------------------------+
    """


class Amazon2014CDs_10104811_ROU(MatchingRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 10
    kcore4item: 10
    star4pos: 4
    ratios: 8,1,1
    splitting: ROU

    Statistics:
    -----------
    +-------+-------+---------------+--------+--------+-------+----------------------+
    | #User | #Item | #Interactions | #Train | #Valid | #Test |       Density        |
    +-------+-------+---------------+--------+--------+-------+----------------------+
    |  9954 | 10877 |     272086    | 213755 | 26342  | 31989 | 0.002513040172344499 |
    +-------+-------+---------------+--------+--------+-------+----------------------+
    """


class Amazon2014CDs_10104712_ROU(MatchingRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 10
    kcore4item: 10
    star4pos: 4
    ratios: 7,1,2
    splitting: ROU

    Statistics:
    -----------
    +-------+-------+---------------+--------+--------+-------+----------------------+
    | #User | #Item | #Interactions | #Train | #Valid | #Test |       Density        |
    +-------+-------+---------------+--------+--------+-------+----------------------+
    |  9954 | 10877 |     272086    | 186347 | 27408  | 58331 | 0.002513040172344499 |
    +-------+-------+---------------+--------+--------+-------+----------------------+
    """


class Amazon2014Movies_10104811_ROU(MatchingRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 10
    kcore4item: 10
    star4pos: 4
    ratios: 7,1,2
    splitting: ROU

    Statistics:
    -----------
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    | #User | #Item | #Interactions | #Train | #Valid | #Test |        Density        |
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    | 21506 | 15269 |     580420    | 455956 | 56162  | 68302 | 0.0017675517274430242 |
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    """


class Amazon2014Movies_10104712_ROU(MatchingRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 10
    kcore4item: 10
    star4pos: 4
    ratios: 7,1,2
    splitting: ROU

    Statistics:
    -----------
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    | #User | #Item | #Interactions | #Train | #Valid | #Test  |        Density        |
    +-------+-------+---------------+--------+--------+--------+-----------------------+
    | 21506 | 15269 |     580420    | 397557 | 58399  | 124464 | 0.0017675517274430242 |
    +-------+-------+---------------+--------+--------+--------+-----------------------+
    """


class Amazon2014Beauty_10104811_ROU(MatchingRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 10
    kcore4item: 10
    star4pos: 4
    ratios: 7,1,2
    splitting: ROU

    Statistics:
    -----------
    +-------+-------+---------------+--------+--------+-------+----------------------+
    | #User | #Item | #Interactions | #Train | #Valid | #Test |       Density        |
    +-------+-------+---------------+--------+--------+-------+----------------------+
    |  973  |  645  |     19263     | 15008  |  1845  |  2410 | 0.030693850235426277 |
    +-------+-------+---------------+--------+--------+-------+----------------------+
    """


class Amazon2014Beauty_10104712_ROU(MatchingRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 10
    kcore4item: 10
    star4pos: 4
    ratios: 7,1,2
    splitting: ROU

    Statistics:
    -----------
    +-------+-------+---------------+--------+--------+-------+----------------------+
    | #User | #Item | #Interactions | #Train | #Valid | #Test |       Density        |
    +-------+-------+---------------+--------+--------+-------+----------------------+
    |  973  |  645  |     19263     | 13063  |  1945  |  4255 | 0.030693850235426277 |
    +-------+-------+---------------+--------+--------+-------+----------------------+
    """


class Amazon2014Electronics_10104811_ROU(MatchingRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 10
    kcore4item: 10
    star4pos: 4
    ratios: 7,1,2
    splitting: ROU

    Statistics:
    -----------
    +-------+-------+---------------+--------+--------+-------+----------------------+
    | #User | #Item | #Interactions | #Train | #Valid | #Test |       Density        |
    +-------+-------+---------------+--------+--------+-------+----------------------+
    |  9279 |  6065 |     158979    | 123648 | 14988  | 20343 | 0.002824930586818252 |
    +-------+-------+---------------+--------+--------+-------+----------------------+
    """


class Amazon2014Electronics_10104712_ROU(MatchingRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 10
    kcore4item: 10
    star4pos: 4
    ratios: 7,1,2
    splitting: ROU

    Statistics:
    -----------
    +-------+-------+---------------+--------+--------+-------+----------------------+
    | #User | #Item | #Interactions | #Train | #Valid | #Test |       Density        |
    +-------+-------+---------------+--------+--------+-------+----------------------+
    |  9279 |  6065 |     158979    | 107674 | 15974  | 35331 | 0.002824930586818252 |
    +-------+-------+---------------+--------+--------+-------+----------------------+
    """


class Amazon2014Baby_550_MMRec(MatchingRecDataSet):
    r"""
    Amazon2014Baby from [MMRec](https://github.com/enoche/MMRec).

    Statistics:
    -----------
    +--------+--------+-------------------+---------------+--------+--------+-------+-----------------------+
    | #Users | #Items |      Avg.Len      | #Interactions | #Train | #Valid | #Test |        Density        |
    +--------+--------+-------------------+---------------+--------+--------+-------+-----------------------+
    | 19445  |  7050  | 8.096734379017743 |     160792    | 118551 | 20559  | 21682 | 0.0011729172479570493 |
    +--------+--------+-------------------+---------------+--------+--------+-------+-----------------------+
    """
    URL = "https://zenodo.org/records/11003225/files/Amazon2014Baby_550_MMRec.zip"


class Amazon2014Sports_550_MMRec(MatchingRecDataSet):
    r"""
    Amazon2014Sports from [MMRec](https://github.com/enoche/MMRec).

    Statistics:
    -----------
    +--------+--------+------------------+---------------+--------+--------+-------+------------------------+
    | #Users | #Items |     Avg.Len      | #Interactions | #Train | #Valid | #Test |        Density         |
    +--------+--------+------------------+---------------+--------+--------+-------+------------------------+
    | 35598  | 18357  | 8.13542895668296 |     296337    | 218409 | 37899  | 40029 | 0.00045348045456958995 |
    +--------+--------+------------------+---------------+--------+--------+-------+------------------------+
    """
    URL = "https://zenodo.org/records/11003225/files/Amazon2014Sports_550_MMRec.zip"


class Amazon2014Clothing_550_MMRec(MatchingRecDataSet):
    r"""
    Amazon2014Clothing from [MMRec](https://github.com/enoche/MMRec).

    Statistics:
    -----------
    +--------+--------+-------------------+---------------+--------+--------+-------+-----------------------+
    | #Users | #Items |      Avg.Len      | #Interactions | #Train | #Valid | #Test |        Density        |
    +--------+--------+-------------------+---------------+--------+--------+-------+-----------------------+
    | 39387  | 23033  | 7.010231802371341 |     278677    | 197338 | 40150  | 41189 | 0.0003071833809100676 |
    +--------+--------+-------------------+---------------+--------+--------+-------+-----------------------+
    """
    URL = "https://zenodo.org/records/11003225/files/Amazon2014Clothing_550_MMRec.zip"


class Amazon2014Electronics_550_MMRec(MatchingRecDataSet):
    r"""
    Amazon2014Electronics from [MMRec](https://github.com/enoche/MMRec).

    Statistics:
    -----------
    +--------+--------+-----------------+---------------+---------+--------+--------+------------------------+
    | #Users | #Items |     Avg.Len     | #Interactions |  #Train | #Valid | #Test  |        Density         |
    +--------+--------+-----------------+---------------+---------+--------+--------+------------------------+
    | 192403 | 63001  | 8.5198619564144 |    1689188    | 1254441 | 211296 | 223451 | 0.00013935376448339807 |
    +--------+--------+-----------------+---------------+---------+--------+--------+------------------------+
    """
    URL = "https://zenodo.org/records/11003225/files/Amazon2014Electronics_550_MMRec.zip"


#===================================NextItemRecDataSset===================================


class Amazon2014Beauty_550_LOU(NextItemRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 5
    kcore4item: 5
    star4pos: 0
    splitting: LOU

    Statistics:
    -----------
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    | #User | #Item | #Interactions | #Train | #Valid | #Test |        Density        |
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    | 22363 | 12101 |     198502    | 153776 | 22363  | 22363 | 0.0007335227064174272 |
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    """


class Amazon2014Beauty_500_LOU(NextItemRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 5
    kcore4item: 0
    star4pos: 0
    splitting: LOU

    Statistics:
    -----------
    +-------+--------+---------------+--------+--------+-------+-----------------------+
    | #User | #Item  | #Interactions | #Train | #Valid | #Test |        Density        |
    +-------+--------+---------------+--------+--------+-------+-----------------------+
    | 52374 | 121291 |     469771    | 365023 | 52374  | 52374 | 7.395063077984393e-05 |
    +-------+--------+---------------+--------+--------+-------+-----------------------+
    """


class Amazon2014Games_550_LOU(NextItemRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 5
    kcore4item: 5
    star4pos: 0
    splitting: LOU

    Statistics:
    -----------
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    | #User | #Item | #Interactions | #Train | #Valid | #Test |        Density        |
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    | 24303 | 10672 |     231780    | 183174 | 24303  | 24303 | 0.0008936557520523778 |
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    """


class Amazon2014Games_500_LOU(NextItemRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 5
    kcore4item: 0
    star4pos: 0
    splitting: LOU

    Statistics:
    -----------
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    | #User | #Item | #Interactions | #Train | #Valid | #Test |        Density        |
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    | 31027 | 33899 |     300003    | 237949 | 31027  | 31027 | 0.0002852324451898322 |
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    """


class Amazon2014Grocery_550_LOU(NextItemRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 5
    kcore4item: 5
    star4pos: 0
    splitting: LOU

    Statistics:
    -----------
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    | #User | #Item | #Interactions | #Train | #Valid | #Test |        Density        |
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    | 14681 |  8713 |     151254    | 121892 | 14681  | 14681 | 0.0011824519884614812 |
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    """


class Amazon2014Grocery_500_LOU(NextItemRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 5
    kcore4item: 0
    star4pos: 0
    splitting: LOU

    Statistics:
    -----------
    +-------+-------+---------------+--------+--------+-------+------------------------+
    | #User | #Item | #Interactions | #Train | #Valid | #Test |        Density         |
    +-------+-------+---------------+--------+--------+-------+------------------------+
    | 32228 | 84357 |     329057    | 264601 | 32228  | 32228 | 0.00012103658242636469 |
    +-------+-------+---------------+--------+--------+-------+------------------------+
    """


class Amazon2014Home_550_LOU(NextItemRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 5
    kcore4user: 5
    kcore4item: 5
    star4pos: 0
    splitting: LOU

    Statistics:
    -----------
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    | #User | #Item | #Interactions | #Train | #Valid | #Test |        Density        |
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    | 66519 | 28237 |     551682    | 418644 | 66519  | 66519 | 0.0002937139329503578 |
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    """


class Amazon2014Home_500_LOU(NextItemRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 5
    kcore4item: 0
    star4pos: 0
    splitting: LOU

    Statistics:
    -----------
    +--------+--------+---------------+--------+--------+--------+-----------------------+
    | #User  | #Item  | #Interactions | #Train | #Valid | #Test  |        Density        |
    +--------+--------+---------------+--------+--------+--------+-----------------------+
    | 115673 | 194446 |     980608    | 749262 | 115673 | 115673 | 4.359778437881578e-05 |
    +--------+--------+---------------+--------+--------+--------+-----------------------+
    """


class Amazon2014Movies_550_LOU(NextItemRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 5
    kcore4item: 5
    star4pos: 0
    splitting: LOU

    Statistics:
    -----------
    +--------+-------+---------------+---------+--------+--------+------------------------+
    | #User  | #Item | #Interactions |  #Train | #Valid | #Test  |        Density         |
    +--------+-------+---------------+---------+--------+--------+------------------------+
    | 123960 | 50052 |    1697533    | 1449613 | 123960 | 123960 | 0.00027359945140758034 |
    +--------+-------+---------------+---------+--------+--------+------------------------+
    """


class Amazon2014Movies_500_LOU(NextItemRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 5
    kcore4item: 0
    star4pos: 0
    splitting: LOU

    Statistics:
    -----------
    +--------+--------+---------------+---------+--------+--------+-----------------------+
    | #User  | #Item  | #Interactions |  #Train | #Valid | #Test  |        Density        |
    +--------+--------+---------------+---------+--------+--------+-----------------------+
    | 139138 | 153436 |    1932230    | 1653954 | 139138 | 139138 | 9.050775575045545e-05 |
    +--------+--------+---------------+---------+--------+--------+-----------------------+
    """


class Amazon2014Office_550_LOU(NextItemRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 5
    kcore4item: 5
    star4pos: 0
    splitting: LOU

    Statistics:
    -----------
    +-------+-------+---------------+--------+--------+-------+----------------------+
    | #User | #Item | #Interactions | #Train | #Valid | #Test |       Density        |
    +-------+-------+---------------+--------+--------+-------+----------------------+
    |  4905 |  2420 |     53258     | 43448  |  4905  |  4905 | 0.004486735579312727 |
    +-------+-------+---------------+--------+--------+-------+----------------------+
    """


class Amazon2014Office_500_LOU(NextItemRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 5
    kcore4item: 0
    star4pos: 0
    splitting: LOU

    Statistics:
    -----------
    +-------+-------+---------------+--------+--------+-------+------------------------+
    | #User | #Item | #Interactions | #Train | #Valid | #Test |        Density         |
    +-------+-------+---------------+--------+--------+-------+------------------------+
    | 16772 | 37956 |     145141    | 111597 | 16772  | 16772 | 0.00022799473561677615 |
    +-------+-------+---------------+--------+--------+-------+------------------------+
    """


class Amazon2014Tools_550_LOU(NextItemRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 5
    kcore4item: 5
    star4pos: 0
    splitting: LOU

    Statistics:
    -----------
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    | #User | #Item | #Interactions | #Train | #Valid | #Test |        Density        |
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    | 16638 | 10217 |     134476    | 101200 | 16638  | 16638 | 0.0007910797527997544 |
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    """


class Amazon2014Tools_500_LOU(NextItemRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 5
    kcore4item: 5
    star4pos: 0
    splitting: LOU

    Statistics:
    -----------
    +-------+--------+---------------+--------+--------+-------+-----------------------+
    | #User | #Item  | #Interactions | #Train | #Valid | #Test |        Density        |
    +-------+--------+---------------+--------+--------+-------+-----------------------+
    | 45791 | 112855 |     390454    | 298872 | 45791  | 45791 | 7.555599745486971e-05 |
    +-------+--------+---------------+--------+--------+-------+-----------------------+
    """


class Amazon2014Toys_550_LOU(NextItemRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 5
    kcore4item: 5
    star4pos: 0
    splitting: LOU

    Statistics:
    -----------
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    | #User | #Item | #Interactions | #Train | #Valid | #Test |        Density        |
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    | 19412 | 11924 |     167597    | 128773 | 19412  | 19412 | 0.0007240590571801228 |
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    """


class Amazon2014Toys_500_LOU(NextItemRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 5
    kcore4item: 0
    star4pos: 0
    splitting: LOU

    Statistics:
    -----------
    +-------+--------+---------------+--------+--------+-------+------------------------+
    | #User | #Item  | #Interactions | #Train | #Valid | #Test |        Density         |
    +-------+--------+---------------+--------+--------+-------+------------------------+
    | 58315 | 165371 |     525535    | 408905 | 58315  | 58315 | 5.4495671989733694e-05 |
    +-------+--------+---------------+--------+--------+-------+------------------------+
    """