

from .base import MatchingRecDataSet, NextItemRecDataSet


#===================================MatchingRecDataSset===================================


class Amazon2023Baby_554811_ROU(MatchingRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 5
    kcore4item: 5
    star4pos: 4
    ratios: 8,1,1
    splitting: ROU

    Statistics:
    -----------
    +-------+-------+---------------+--------+--------+--------+------------------------+
    | #User | #Item | #Interactions | #Train | #Valid | #Test  |        Density         |
    +-------+-------+---------------+--------+--------+--------+------------------------+
    | 94207 | 33086 |     756243    | 571033 | 71777  | 113433 | 0.00024262409491624325 |
    +-------+-------+---------------+--------+--------+--------+------------------------+
    """


class Amazon2023Beauty_554811_ROU(MatchingRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 5
    kcore4item: 5
    star4pos: 4
    ratios: 8,1,1
    splitting: ROU

    Statistics:
    -----------
    +--------+--------+---------------+---------+--------+--------+-----------------------+
    | #User  | #Item  | #Interactions |  #Train | #Valid | #Test  |        Density        |
    +--------+--------+---------------+---------+--------+--------+-----------------------+
    | 445360 | 187676 |    3972713    | 3016546 | 380101 | 576066 | 4.752993765386623e-05 |
    +--------+--------+---------------+---------+--------+--------+-----------------------+
    """


class Amazon2023Beauty_10104811_ROU(MatchingRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 10
    kcore4item: 10
    star4pos: 4
    ratios: 8,1,1
    splitting: ROU

    Statistics:
    -----------
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    | #User | #Item | #Interactions | #Train | #Valid | #Test |        Density        |
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    | 23873 | 30380 |     526100    | 411845 | 50406  | 63849 | 0.0007253932904278116 |
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    """


class Amazon2023Books_10104811_ROU(MatchingRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 10
    kcore4item: 10
    star4pos: 4
    ratios: 8,1,1
    splitting: ROU

    Statistics:
    -----------
    +-------+-------+---------------+---------+--------+--------+------------------------+
    | #User | #Item | #Interactions |  #Train | #Valid | #Test  |        Density         |
    +-------+-------+---------------+---------+--------+--------+------------------------+
    | 95999 | 80033 |    2219164    | 1737808 | 213623 | 267733 | 0.00028883751032548864 |
    +-------+-------+---------------+---------+--------+--------+------------------------
    """


class Amazon2023Fashion_554811_ROU(MatchingRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 5
    kcore4item: 5
    star4pos: 4
    ratios: 8,1,1
    splitting: ROU

    Statistics:
    -----------
    +-------+-------+---------------+--------+--------+-------+--------------------+
    | #User | #Item | #Interactions | #Train | #Valid | #Test |      Density       |
    +-------+-------+---------------+--------+--------+-------+--------------------+
    |  182  |  194  |      1073     |  814   |   73   |  186  | 0.0303897133794041 |
    +-------+-------+---------------+--------+--------+-------+--------------------+
    """


class Amazon2023Games_554811_ROU(MatchingRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 5
    kcore4item: 5
    star4pos: 4
    ratios: 8,1,1
    splitting: ROU

    Statistics:
    -----------
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    | #User | #Item | #Interactions | #Train | #Valid | #Test |        Density        |
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    | 62142 | 22977 |     527547    | 399535 | 50302  | 77710 | 0.0003694729148213664 |
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    """


class Amazon2023Office_554811_ROU(MatchingRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 5
    kcore4item: 5
    star4pos: 4
    ratios: 8,1,1
    splitting: ROU

    Statistics:
    -----------
    +--------+-------+---------------+--------+--------+--------+------------------------+
    | #User  | #Item | #Interactions | #Train | #Valid | #Test  |        Density         |
    +--------+-------+---------------+--------+--------+--------+------------------------+
    | 140844 | 64849 |    1136291    | 858947 | 106855 | 170489 | 0.00012440789240741342 |
    +--------+-------+---------------+--------+--------+--------+------------------------+
    """


class Amazon2023Toys_554811_ROU(MatchingRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 5
    kcore4item: 5
    star4pos: 4
    ratios: 8,1,1
    splitting: ROU

    Statistics:
    -----------
    +--------+--------+---------------+---------+--------+--------+-----------------------+
    | #User  | #Item  | #Interactions |  #Train | #Valid | #Test  |        Density        |
    +--------+--------+---------------+---------+--------+--------+-----------------------+
    | 309666 | 140148 |    2771911    | 2104274 | 265912 | 401725 | 6.387028486374657e-05 |
    +--------+--------+---------------+---------+--------+--------+-----------------------+
    """


class Amazon2023Toys_10104811_ROU(MatchingRecDataSet):
    r"""
    Settings:
    ---------
    kcore4user: 10
    kcore4item: 10
    star4pos: 4
    ratios: 8,1,1
    splitting: ROU

    Statistics:
    -----------
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    | #User | #Item | #Interactions | #Train | #Valid | #Test |        Density        |
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    | 13383 | 10551 |     214069    | 166194 | 20109  | 27766 | 0.0015160261038719765 |
    +-------+-------+---------------+--------+--------+-------+-----------------------+
    """




#===================================NextItemRecDataSset===================================